#include	<stdio.h>
#include	<time.h>
#include	<errno.h>

#define	LMAXM	   " 2147483646"
#define	LMAX	   " 2147483647"
#define	LMAXP	   " 2147483648"
#define	LMINP	   "-2147483647"
#define	LMIN	   "-2147483648"
#define	LMINM	   "-2147483649"
#define ULMAXM	   "4294967294"
#define ULMAX	   "4294967295"
#define ULMAXP	   "4294967296"

#define LLMAXM	   " 9223372036854775806"
#define LLMAX	   " 9223372036854775807"
#define LLMAXP	   " 9223372036854775808"
#define LLMINP	   "-9223372036854775807"
#define LLMIN	   "-9223372036854775808"
#define LLMINM	   "-9223372036854775809"
#define ULLMAXM	   "18446744073709551614"
#define ULLMAX	   "18446744073709551615"
#define ULLMAXP	   "18446744073709551616"

extern long strtol(const char* str, char** end, int base);
extern unsigned long strtoul(const char* str, char** end, int base);
extern long long strtoll(const char* str, char** end, int base);
extern unsigned long long strtoull(const char* str, char** end, int base);

void	subs(char* valstr)
{
	errno = 0;
	printf("%s: err=%s, val=%+ld\n", valstr, (errno?"yes":"no "), strtol(valstr, 0, 10));
}

void	subu(char* valstr)
{
	errno = 0;
	printf("%s: err=%s, val=%+lu\n", valstr, (errno?"yes":"no "), strtoul(valstr, 0, 10));
}

void	subsll(char* valstr)
{
	errno = 0;
	printf("%s: err=%s, val=%+Ld\n", valstr, (errno?"yes":"no "), strtoll(valstr, 0, 10));
}

void	subull(char* valstr)
{
	errno = 0;
	printf("%s: err=%s, val=%+Lu\n", valstr, (errno?"yes":"no "), strtoull(valstr, 0, 10));
}

void	main(void)
{
	printf("\nlong long overflow check...\n");
	subs(LMAXM);
	subs(LMAX );
	subs(LMAXP);
	subs(LMINP);
	subs(LMIN );
	subs(LMINM);

	printf("\nunsigned long long overflow check...\n");
	subu(ULMAXM);
	subu(ULMAX );
	subu(ULMAXP);

	printf("\nlong long overflow check...\n");
	subsll(LLMAXM);
	subsll(LLMAX );
	subsll(LLMAXP);
	subsll(LLMINP);
	subsll(LLMIN );
	subsll(LLMINM);

	printf("\nunsigned long long overflow check...\n");
	subull(ULLMAXM);
	subull(ULLMAX );
	subull(ULLMAXP);
}
